##############################################################################
# $Id: passwd.pl,v 1.2 1999/08/26 04:06:57 jheiss Exp $
##############################################################################
# Subroutine for getting a password from a user.
##############################################################################
# Copyright (C) 1999  Jason Heiss (jheiss@ofb.net)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
##############################################################################
# Pre-RCS version control:
# created 09/26/97
# last modified 09/26/97
##############################################################################
# $Log: passwd.pl,v $
# Revision 1.2  1999/08/26 04:06:57  jheiss
# Added copyright and GNU license message.
#
# Revision 1.1  1999/08/09 03:05:51  jheiss
# Initial revision
#
##############################################################################

sub getpass
{
	my $prompt = $_[0];

	my $rootpass = '1';
	my $rootpassconf = '2';

	# Turn off echo so that the user's keystrokes don't show up on the
	# screen.
	system("stty -echo");

	my $oldsigint = $SIG{'INT'};
	$SIG{'INT'} = \&reecho;

	while($rootpass ne $rootpassconf)
	{
        	print "Enter $prompt: ";
        	chop($rootpass = <STDIN>);
        	print "\n";
        	print "Re-enter $prompt to confirm: ";
        	chop($rootpassconf = <STDIN>);
        	print "\n";
 
        	if ($rootpass ne $rootpassconf)
        	{
                	print "Passwords don't match, try again.\n";
        	}
	}

	if (defined($oldsigint))
	{
		$SIG{'INT'} = $oldsigint;
	}
	system("stty echo");

	return $rootpass;
}

sub reecho
{
	system("stty echo");
	exit;
}

return 1;

